Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/AddDocumentDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/AddDocumentDialog.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/AddDocumentDialog.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2012-2015 Hippo B.V. (http://www.onehippo.com)
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -40,6 +40,7 @@
 import org.apache.wicket.util.value.IValueMap;
 import org.hippoecm.addon.workflow.AbstractWorkflowDialog;
 import org.hippoecm.addon.workflow.IWorkflowInvoker;
+import org.hippoecm.frontend.dialog.DialogConstants;
 import org.hippoecm.frontend.i18n.types.SortedTypeChoiceRenderer;
 import org.hippoecm.frontend.plugins.standards.list.resolvers.CssClassAppender;
 import org.hippoecm.frontend.plugins.standardworkflow.components.LanguageField;
@@ -47,23 +48,26 @@
 import org.hippoecm.repository.api.StringCodec;
 
 public class AddDocumentDialog extends AbstractWorkflowDialog<AddDocumentArguments> {
-    private IModel title;
+
+    private IModel<String> title;
     private TextField nameComponent;
     private TextField uriComponent;
     private boolean uriModified = false;
     private LanguageField languageField;
     private final IModel<StringCodec> nodeNameCodecModel;
 
-    public AddDocumentDialog(AddDocumentArguments addDocumentModel, IModel title, String category, Set<String> prototypes, boolean translated, final IWorkflowInvoker invoker, IModel<StringCodec> nodeNameCodec, ILocaleProvider localeProvider) {
+    public AddDocumentDialog(AddDocumentArguments addDocumentModel, IModel<String> title, String category,
+                             Set<String> prototypes, boolean translated, final IWorkflowInvoker invoker,
+                             IModel<StringCodec> nodeNameCodec, ILocaleProvider localeProvider) {
         super(Model.of(addDocumentModel), invoker);
         this.title = title;
         this.nodeNameCodecModel = nodeNameCodec;
 
-        final PropertyModel<String> nameModel = new PropertyModel<String>(addDocumentModel, "targetName");
-        final PropertyModel<String> uriModel = new PropertyModel<String>(addDocumentModel, "uriName");
-        final PropertyModel<String> prototypeModel = new PropertyModel<String>(addDocumentModel, "prototype");
+        final PropertyModel<String> nameModel = new PropertyModel<>(addDocumentModel, "targetName");
+        final PropertyModel<String> uriModel = new PropertyModel<>(addDocumentModel, "uriName");
+        final PropertyModel<String> prototypeModel = new PropertyModel<>(addDocumentModel, "prototype");
 
-        nameComponent = new TextField<String>("name", new IModel<String>() {
+        nameComponent = new TextField<>("name", new IModel<String>() {
             private static final long serialVersionUID = 1L;
 
             public String getObject() {
@@ -102,14 +106,14 @@
         setFocus(nameComponent);
         add(nameComponent);
 
-        final Label typelabel;
-        add(typelabel = new Label("typelabel", new StringResourceModel("document-type", this, null)));
+        final Label typeLabel;
+        add(typeLabel = new Label("typelabel", new StringResourceModel("document-type", this, null)));
 
         if (prototypes.size() > 1) {
-            final List<String> prototypesList = new LinkedList<String>(prototypes);
+            final List<String> prototypesList = new LinkedList<>(prototypes);
             final DropDownChoice<String> folderChoice;
             SortedTypeChoiceRenderer typeChoiceRenderer = new SortedTypeChoiceRenderer(this, prototypesList);
-            add(folderChoice = new DropDownChoice<String>("prototype", prototypeModel, typeChoiceRenderer, typeChoiceRenderer));
+            add(folderChoice = new DropDownChoice<>("prototype", prototypeModel, typeChoiceRenderer, typeChoiceRenderer));
             folderChoice.add(new AjaxFormComponentUpdatingBehavior("onchange") {
                 @Override
                 protected void onUpdate(AjaxRequestTarget target) {
@@ -119,19 +123,16 @@
             folderChoice.setNullValid(false);
             folderChoice.setRequired(true);
             folderChoice.setLabel(new StringResourceModel("document-type", this, null));
+
             // while not a prototype chosen, disable ok button
-            Component notypes;
-            add(notypes = new EmptyPanel("notypes"));
-            notypes.setVisible(false);
+            add(new EmptyPanel("notypes").setVisible(false));
         } else if (prototypes.size() == 1) {
             Component component;
             add(component = new EmptyPanel("prototype"));
             component.setVisible(false);
             prototypeModel.setObject(prototypes.iterator().next());
-            Component notypes;
-            add(notypes = new EmptyPanel("notypes"));
-            notypes.setVisible(false);
-            typelabel.setVisible(false);
+            add(new EmptyPanel("notypes").setVisible(false));
+            typeLabel.setVisible(false);
         } else {
             // if the folderWorkflowPlugin.templates.get(category).size() = 0 you cannot add this
             // category currently.
@@ -142,7 +143,7 @@
             add(new Label("notypes", "There are no types available for : [" + category
                     + "] First create document types please."));
             nameComponent.setVisible(false);
-            typelabel.setVisible(false);
+            typeLabel.setVisible(false);
         }
 
         add(uriComponent = new TextField<String>("uriinput", uriModel) {
@@ -192,13 +193,13 @@
     }
 
     @Override
-    public IModel getTitle() {
+    public IModel<String> getTitle() {
         return title;
     }
 
     @Override
     public IValueMap getProperties() {
-        return MEDIUM;
+        return DialogConstants.MEDIUM;
     }
 
     public LanguageField getLanguageField() {
Index: engine/src/main/java/org/hippoecm/frontend/service/settings/SettingsStorePlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- engine/src/main/java/org/hippoecm/frontend/service/settings/SettingsStorePlugin.java	(revision 48312)
+++ engine/src/main/java/org/hippoecm/frontend/service/settings/SettingsStorePlugin.java	(revision )
@@ -16,13 +16,12 @@
 package org.hippoecm.frontend.service.settings;
 
 import java.util.HashMap;
-import java.util.HashSet;
 import java.util.Map;
-import org.hippoecm.frontend.service.ISettingsService;
-import org.hippoecm.frontend.service.preferences.*;
+
 import org.hippoecm.frontend.plugin.IPluginContext;
 import org.hippoecm.frontend.plugin.Plugin;
 import org.hippoecm.frontend.plugin.config.IPluginConfig;
+import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.repository.api.StringCodec;
 import org.hippoecm.repository.api.StringCodecFactory;
 import org.slf4j.Logger;
@@ -30,11 +29,9 @@
 
 public class SettingsStorePlugin extends Plugin implements ISettingsService {
     private static final long serialVersionUID = 1L;
-    @SuppressWarnings("unused")
 
+    public static final Logger log = LoggerFactory.getLogger(SettingsStorePlugin.class);
 
-    static final Logger log = LoggerFactory.getLogger(SettingsStorePlugin.class);
-
     transient StringCodecFactory stringCodecFactory;
 
     public SettingsStorePlugin(IPluginContext context, IPluginConfig config) {
@@ -46,19 +43,13 @@
     public StringCodecFactory getStringCodecFactory() {
         if (stringCodecFactory == null) {
             IPluginConfig codecsConfig = getPluginConfig().getPluginConfig("codecs");
-            Map<String, StringCodec> codecs = new HashMap<String, StringCodec>();
+            Map<String, StringCodec> codecs = new HashMap<>();
             for (String codecName : codecsConfig.keySet()) {
                 try {
                     String className = codecsConfig.getString(codecName);
                     Class<? extends StringCodec> clazz = Thread.currentThread().getContextClassLoader().loadClass(className).asSubclass(StringCodec.class);
                     codecs.put(codecName, clazz.newInstance());
-                } catch (InstantiationException ex) {
-                    log.error("unable to create " + codecName, ex);
-                } catch (IllegalAccessException ex) {
-                    log.error("unable to create " + codecName, ex);
-                } catch (ClassCastException ex) {
-                    log.error("1`unable to create " + codecName, ex);
-                } catch (ClassNotFoundException ex) {
+                } catch (InstantiationException | ClassNotFoundException | ClassCastException | IllegalAccessException ex) {
                     log.error("unable to create " + codecName, ex);
                 }
             }
Index: workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/RenameDocumentDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/RenameDocumentDialog.java	(revision 48312)
+++ workflow/frontend/src/main/java/org/hippoecm/frontend/plugins/reviewedactions/RenameDocumentDialog.java	(revision )
@@ -34,27 +34,25 @@
 import org.apache.wicket.util.value.IValueMap;
 import org.hippoecm.addon.workflow.AbstractWorkflowDialog;
 import org.hippoecm.addon.workflow.StdWorkflow;
-import org.hippoecm.frontend.plugin.IPluginContext;
+import org.hippoecm.frontend.dialog.DialogConstants;
 import org.hippoecm.frontend.plugins.standards.list.resolvers.CssClassAppender;
 import org.hippoecm.frontend.plugins.standardworkflow.RenameMessage;
-import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.repository.api.Localized;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 
 public  class RenameDocumentDialog extends AbstractWorkflowDialog<Void> {
         private IModel<String> title;
-        private TextField nameComponent;
-        private TextField uriComponent;
+        private IModel<StringCodec> codec;
+        private TextField<String> nameComponent;
+        private TextField<String> uriComponent;
         private boolean uriModified;
-        private IPluginContext context;
 
-        public RenameDocumentDialog(StdWorkflow action, IModel<String> title, IPluginContext context) {
+        public RenameDocumentDialog(StdWorkflow action, IModel<String> title, IModel<StringCodec> codecModel) {
             super(null, action);
 
             this.title = title;
-            this.context = context;
+            this.codec = codecModel;
 
             final PropertyModel<String> nameModel = new PropertyModel<>(action, "targetName");
             final PropertyModel<String> uriModel = new PropertyModel<>(action, "uriName");
@@ -72,12 +70,26 @@
                 @Override
                 protected void onUpdate(AjaxRequestTarget target) {
                     if (!uriModified) {
-                        uriModel.setObject(getNodeNameCodec().encode(nameModel.getObject()));
+                        String encoded = codec.getObject().encode(nameModel.getObject());
+                        uriModel.setObject(encoded);
                         target.add(uriComponent);
                     }
                 }
 
                 @Override
+                protected void onError(final AjaxRequestTarget target, final RuntimeException e) {
+                    super.onError(target, e);
+
+                    //if we get past the super call, RunTimeException e is null and we are dealing with
+                    //either a validation or a conversion error, so we can/should update the URI component if needed
+                    String rawInput = nameComponent.getInput();
+                    if (!uriModified && Strings.isEmpty(rawInput)) {
+                        uriModel.setObject("");
+                        target.add(uriComponent);
+                    }
+                }
+
+                @Override
                 protected void updateAjaxAttributes(final AjaxRequestAttributes attributes) {
                     super.updateAjaxAttributes(attributes);
                     attributes.setThrottlingSettings(new ThrottlingSettings(nameComponent.getPath(), Duration.milliseconds(500)));
@@ -107,8 +119,9 @@
                 public void onClick(AjaxRequestTarget target) {
                     uriModified = !uriModified;
                     if (!uriModified) {
-                        uriModel.setObject(Strings.isEmpty(nameModel.getObject()) ? "" : getNodeNameCodec().encode(
-                                nameModel.getObject()));
+                        String uri = Strings.isEmpty(nameModel.getObject()) ? ""
+                                : codec.getObject().encode(nameModel.getObject());
+                        uriModel.setObject(uri);
                     } else {
                         target.focusComponent(uriComponent);
                     }
@@ -130,13 +143,6 @@
             }
         }
 
-        protected StringCodec getNodeNameCodec() {
-            ISettingsService settingsService = context.getService(ISettingsService.SERVICE_ID,
-                    ISettingsService.class);
-            StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-            return stringCodecFactory.getStringCodec("encoding.node");
-        }
-
         @Override
         public IModel<String> getTitle() {
             return title;
@@ -144,6 +150,6 @@
 
         @Override
         public IValueMap getProperties() {
-            return MEDIUM;
+            return DialogConstants.MEDIUM;
         }
     }
\ No newline at end of file
Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/NameUriField.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/NameUriField.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/NameUriField.java	(revision )
@@ -37,31 +37,30 @@
 public class NameUriField extends WebMarkupContainer {
     private static final long serialVersionUID = 1L;
 
-    private final Component urlComponent;
-
-    private boolean urlModified = false;
-
-    private PropertyModel<String> urlModel;
-    private PropertyModel<String> nameModel;
-
-    private String name;
+    @SuppressWarnings("unused")
     private String url;
+    @SuppressWarnings("unused")
+    private String name;
-    
+
-    private Component nameComponent;
+    private final Component urlComponent;
+    private final Component nameComponent;
 
+    private final PropertyModel<String> urlModel;
+    private final PropertyModel<String> nameModel;
     private final IModel<StringCodec> codecModel;
 
+    private boolean urlModified = false;
+
     public NameUriField(String id, IModel<StringCodec> codecModel) {
         super(id);
         this.codecModel = codecModel;
 
-        nameModel = new PropertyModel<String>(this, "name");
-        urlModel = new PropertyModel<String>(this, "url");
+        urlModel = PropertyModel.of(this, "url");
+        nameModel = PropertyModel.of(this, "name");
 
-        nameComponent = createNameComponent(nameModel);
-        add(nameComponent);
+        add(urlComponent = createUriComponent(urlModel));
+        add(nameComponent = createNameComponent(nameModel));
 
-        add(urlComponent = createUriComponent(nameModel, urlModel));
         add(createUrlAction());
     }
 
@@ -74,12 +73,12 @@
         super.onBeforeRender();
     }
 
-    private StringCodec getNodeNameCodec() {
-        return codecModel.getObject();
+    private String encode(final IModel<String> text) {
+        return codecModel.getObject().encode(text.getObject());
     }
     
     private Component createNameComponent(final PropertyModel<String> nameModel) {
-        final FormComponent nameComponent = new TextField<String>("name", new IModel<String>() {
+        final FormComponent nameComponent = new TextField<>("name", new IModel<String>() {
             private static final long serialVersionUID = 1L;
 
             public String getObject() {
@@ -89,7 +88,7 @@
             public void setObject(String object) {
                 nameModel.setObject(object);
                 if (!urlModified) {
-                    urlModel.setObject(getNodeNameCodec().encode(nameModel.getObject()));
+                    urlModel.setObject(encode(nameModel));
                 }
             }
 
@@ -117,7 +116,7 @@
         return nameComponent;
     }
 
-    private Component createUriComponent(final PropertyModel<String> nameModel, final PropertyModel<String> urlModel) {
+    private Component createUriComponent(final PropertyModel<String> urlModel) {
         FormComponent urlComponent = new TextField<String>("url", urlModel) {
             @Override
             public boolean isEnabled() {
@@ -141,8 +140,7 @@
             public void onClick(AjaxRequestTarget target) {
                 urlModified = !urlModified;
                 if (!urlModified) {
-                    urlModel.setObject(Strings.isEmpty(nameModel.getObject()) ? "" : getNodeNameCodec().encode(
-                            nameModel.getObject()));
+                    urlModel.setObject(Strings.isEmpty(nameModel.getObject()) ? "" : encode(nameModel));
                 } else {
                     target.focusComponent(urlComponent);
                 }
@@ -164,5 +162,16 @@
 
     public String getUrl() {
         return url;
+    }
+
+    public void encodeUri() {
+        if (!urlModified) {
+            final String name = Strings.isEmpty(nameModel.getObject()) ? "" : encode(nameModel);
+            urlModel.setObject(name);
+            AjaxRequestTarget target = RequestCycle.get().find(AjaxRequestTarget.class);
+            if (target != null) {
+                target.add(urlComponent);
+            }
+        }
     }
 }
Index: gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryWorkflowPlugin.java	(revision 48312)
+++ gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryWorkflowPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2009-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2009-2015 Hippo B.V. (http://www.onehippo.com)
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -53,6 +53,7 @@
 import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.frontend.translation.ILocaleProvider;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.frontend.widgets.AbstractView;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
@@ -121,18 +122,20 @@
 
     private void createGalleryItem(FileUpload upload) throws GalleryException {
         try (InputStream is = upload.getInputStream()) {
-            String filename = upload.getClientFileName();
-            String mimetype = upload.getContentType();
+            String fileName = upload.getClientFileName();
+            String mimeType = upload.getContentType();
 
             WorkflowManager manager = UserSession.get().getWorkflowManager();
             HippoNode node;
             try {
                 WorkflowDescriptorModel workflowDescriptorModel = (WorkflowDescriptorModel) GalleryWorkflowPlugin.this
                         .getDefaultModel();
+
                 GalleryWorkflow workflow = (GalleryWorkflow) manager
                         .getWorkflow(workflowDescriptorModel.getObject());
-                String nodeName = getNodeNameCodec().encode(filename);
-                String localName = getLocalizeCodec().encode(filename);
+
+                String nodeName = getNodeNameCodec(workflowDescriptorModel.getNode()).encode(fileName);
+                String localName = getLocalizeCodec().encode(fileName);
                 Document document = workflow.createGalleryItem(nodeName, type);
                 node = (HippoNode) UserSession.get().getJcrSession()
                         .getNodeByIdentifier(document.getIdentity());
@@ -149,14 +152,14 @@
             }
 
             try {
-                getGalleryProcessor().makeImage(node, is, mimetype, filename);
+                getGalleryProcessor().makeImage(node, is, mimeType, fileName);
                 node.getSession().save();
                 onGalleryItemCreation(node);
                 newItems.add(node.getPath());
             } catch (Exception ex) {
                 remove(manager, node);
                 final StringResourceModel messageModel = new StringResourceModel("upload-failed-named-label",
-                        GalleryWorkflowPlugin.this, null, null, filename);
+                        GalleryWorkflowPlugin.this, null, null, fileName);
                 throw new GalleryException(messageModel.getString(), ex);
             }
         } catch (IOException ex) {
@@ -259,17 +262,11 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    protected StringCodec getNodeNameCodec(final Node node) {
+        return CodecUtils.getNodeNameCodec(getPluginContext(), node);
     }
 
     protected ILocaleProvider getLocaleProvider() {
